#
# Conditional build:
%bcond_without	tests	# do not perform "make test"

%define		module	larch
Summary:	Python B-tree library
Name:		python-%{module}
Version:	1.20151025
Release:	1
License:	GPL v3+
Group:		Libraries/Python
Source0:	http://code.liw.fi/debian/pool/main/p/python-%{module}/%{name}_%{version}.orig.tar.xz
# Source0-md5:	1c7dd2ed0bfc377ad04694e7ddb4164b
Patch0:		make-tests.patch
Patch1:		sphinx2.patch
URL:		http://liw.fi/larch/
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.710
# build-time only
BuildRequires:	cmdtest
BuildRequires:	sphinx-pdg-2
BuildRequires:	python-coverage-test-runner
# build- and run-time
BuildRequires:	python-cliapp
BuildRequires:	python-tracing
BuildRequires:	python-ttystatus
Requires:	python-cliapp
Requires:	python-tracing
Requires:	python-ttystatus
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is an implementation of particular kind of B-tree, based on
research by Ohad Rodeh. See "B-trees, Shadowing, and Clones" (copied
here with permission of author) for details on the data structure.
This is the same data structure that btrfs uses. Note that my
implementation is independent from the btrfs one, and might differ
from what the paper describes.

The distinctive feature of this B-tree is that a node is never
modified (sort-of). Instead, all updates are done by copy-on-write.
Among other things, this makes it easy to clone a tree, and modify
only the clone, while other processes access the original tree. This
is utterly wonderful for my backup application, and that's the reason
I wrote larch in the first place.

I have tried to keep the implementation generic and flexible, so that
you may use it in a variety of situations. For example, the tree
itself does not decide where its nodes are stored: you provide a class
that does that for it. I have two implementations of the NodeStore
class, one for in-memory and one for on-disk storage.

The tree attempts to guarantee this: all modifications you make will
be safely stored in the node store when the larch.Forest.commit method
is called. After that, unless you actually modify the committed tree
yourself, it will be safe from further modifications. (You need to
take care to create a new tree for further modifications, though.)

%package doc
Summary:	Documentation for %{module}
Requires:	%{name} = %{version}-%{release}

%description doc
This package contains the documentation for %{module}, a Python
framework for Unix command line programs.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%if %{with tests}
# CoverageTestRunner trips up on build directory;
# remove it first
rm -rf build
%{__make} check
%endif

%py_build

# Build documentation
%{__make} PYTHONPATH=$(pwd)

%install
rm -rf $RPM_BUILD_ROOT
%py_install

# manpage not installed automatically yet
install -d $RPM_BUILD_ROOT%{_mandir}/man1
cp -p fsck-larch.1 $RPM_BUILD_ROOT%{_mandir}/man1

# drop internal tests
%{__rm} $RPM_BUILD_ROOT%{py_sitescriptdir}/larch/*_tests.py*

%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc NEWS README
%attr(755,root,root) %{_bindir}/fsck-larch
%{_mandir}/man1/fsck-larch.1*
%{py_sitescriptdir}/larch-%{version}-py*.egg-info
%dir %{py_sitescriptdir}/larch
%{py_sitescriptdir}/larch/*.py[co]

%files doc
%defattr(644,root,root,755)
%doc doc/_build/html/*
%changelog
* Thu Mar 09 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-larch.git;a=log;h=master

* Thu Mar 09 2017 Jan Rękorajski <baggins@pld-linux.org> a9043ab
- up to 1.20151025

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 4352aed
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 72f8371
- release 2 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 894a81a
- automatic change: use py_build/py_install macros

* Mon Jan 20 2014 Elan Ruusamäe <glen@delfi.ee> b0cb638
- new, version 1.20130808

